
var AirportWindow = null;
var airports      = [];
var airporttimer  = null;

function airportPopup( ref)
{
  if( AirportWindow && !AirportWindow.closed) {
    AirportWindow.close();
  }

  var airportX = posX + 90;
  var airportY = posY - 250;

  AirportWindow = window.open( 'aa.fly?ref='+ ref, 'airport', 'menubar=0,toolbar=0,status=0,scrollbars=auto,resizable=0,width=350,height=490,left=' + airportX + ',screenX=' + airportX + ',top=' + airportY + ',screenY='+ airportY);

  AirportWindow.focus();
}

function updateAirport( ref, airport)
{
  getElement( ref).value = airport;
  hide( 'airportlist_' + ref);
}

function airportKeyPress( event)
{
  if( !event) event = window.event;

  var key       = this.id;
  var airport   = this.value.toLowerCase();
  var code      = event.which || event.keyCode;
  var selection = getElement( 'select_' + key);

  // stop the airport timer
  stopAirportTimer();

  if( code == 13) { // return key
    if( selection.selectedIndex >= 0) {
      this.value = selection[selection.selectedIndex].value;

      // hide the airport list
      hide( 'airportlist_' + key);
    } else if( airport != '' && airports[airport] &&
               airports[airport].length > 1) {
      var result = airports[airport][1].split( '~');

      // take the first from the list
      this.value = result[1];

      // hide the airport list
      hide( 'airportlist_' + key);
    }

    // stop the event (no form submit)
    stopEvent( event);
  }

  // up arrow key
  // down arrow key
  if( code == 38 || code == 40) {
    stopEvent( event);
  }
}

function airportKeyUp( event)
{
  if( !event) event = window.event;

  var key       = this.id;
  var airport   = this.value.toLowerCase();
  var code      = event.which || event.keyCode;
  var selection = getElement( 'select_' + key);

  // stop the airport timer
  stopAirportTimer();

  // handle arrow up and down here (for safari)
  if( airport != '' && (code == 38 || code == 40)) {
    // up arrow key or down arrow key
    if( code == 38) { // up arrow key
      if( selection.selectedIndex < 1) {
        selection.selectedIndex = selection.length-1;
      } else {
        selection.selectedIndex--;
      }
    } else if( code == 40) { // down arrow key
      if( selection.selectedIndex < selection.length-1) {
        selection.selectedIndex++;
      } else {
        selection.selectedIndex = 0;
      }
    }

    this.value = selection[selection.selectedIndex].value;

    // stop the event
    stopEvent( event);
    return;
  }

  // up arrow key or down arrow key
  // left arrow key or right arrow key
  // return key
  if( code == 38 || code == 40 || code == 37 || code == 39 || code == 13) {
    return;
  }

  if( airport == '' || airports[airport]) {
    airporttimer = window.setTimeout( 'updateAirportlist( "' + key + '", "' + airport + '")', 500);
  } else if( airport.length > 0) {
    airporttimer = window.setTimeout( 'getAirports( "' + key + '", "' + airport + '")', 500);
  } else {
    // hide the airport list
    hide( 'airportlist_' + key);
  }
}

function getAirports( key, value)
{
  var http = getHTTP();
  if( !http) {
    return;
  }

  if( typeof screen_type == 'undefined') {
    screen_type = '';
  }

  http.open( 'post', 'ap.fly?action=airport&value=' + encodeURI( value) + '&screen_type=' + screen_type);
  http.onreadystatechange = function() { getAirportsDone( key, http); };
  http.send( null);
}

function getAirportsDone( key, http)
{
  if( !isOKHTTP( http)) {
    return;
  }

  var result = http.responseText.split( '|');

  airports[result[0]] = result;
  updateAirportlist( key, result[0]);
}

function updateAirportlist( key, airport)
{
  if( airport == '' || airports[airport].length < 2) {
    hide( 'airportlist_' + key);
    return;
  }

  var selection = getElement( 'select_' + key);

  selection.length = 0;

  for( var i = 1; i < airports[airport].length; i++) {
    if( airports[airport][i].length > 0) {
      var result = airports[airport][i].split( '~');
      var name   = result[1];
      selection.options[i-1] = new Option( name, name);
    }
  }

  show( 'airportlist_' + key);
}

function selectAirportKeyPress( event)
{
  if( !event) event = window.event;

  var result = this.id.split( '_');
  var key    = result[1] + '_' + result[2];
  var code   = event.which || event.keyCode;

  // stop the airport timer
  stopAirportTimer();

  if( code == 13) { // return key
    if( this.selectedIndex >= 0) {
      // set the airport value
      getElement( key).value = this[this.selectedIndex].value;

      window.setTimeout( 'hide( "airportlist_' + key + '")', 123);
    }

    stopEvent( event);
  }
}

function selectAirportOnClick()
{
  var result = this.id.split( '_');

  if( typeof result[2] == 'undefined') {
    var key = result[1]
  } else {
    var key = result[1] + '_' + result[2];
  }

  getElement( key).value = this.value;

  window.setTimeout( 'hide( "airportlist_' + key + '")', 123);
}

// *****************************************************************
// stop the airport timer if running
// *****************************************************************
function stopAirportTimer()
{
  if( airporttimer) {
    window.clearTimeout( airporttimer);
    airporttimer = null;
  }
}
