var CalendarWindow = null;

function calendarPopup( ref, lang)
{
  var day   = getElement( 'day' + ref).value;
  var month = getElement( 'month' + ref).value;

  var today     = new Date();
  var thismonth = today.getMonth() + 1;
  var year      = today.getFullYear();

  if( day == '') {
    day = today.getDate() + 1;
    getElement( 'day' + ref).selectedIndex = day;
  }

  if( month == '') {
    month = thismonth;
    getElement( 'month' + ref).selectedIndex = month;
  }

  if( thismonth > month) year++;

  if( CalendarWindow && !CalendarWindow.closed) {
    CalendarWindow.close();
  }

  var calendarX = posX + 50;
  var calendarY = posY - 100;

  var popW;
  if( lang == 'fr' || lang == 'da' || lang == 'es') {
    popW = 240;
  } else if( lang == 'tr') {
    popW = 322;
  } else {
    popW = 230;
  }

  CalendarWindow = window.open( 'calendar.fly?ref='+ ref + '&day=' + day + '&month=' + month + '&year=' + year, 'calendar','menubar=0,toolbar=0,status=0,scrollbars=auto,resizable=0,width=' + popW + ',height=200,left=' + calendarX + ',screenX=' + calendarX + ',top=' + calendarY + ',screenY=' + calendarY);

  CalendarWindow.focus();
}

function updateDay( day, seg)
{
  if( getElement( 'day' + seg)[0].value != '') {
    day--;
  }

  getElement( 'day' + seg).selectedIndex = day;

  updateCalendar( seg);
}

function updateMonth( month, seg)
{
  if( month < 0)  month += 12;
  if( month > 11) month = 0;

  if( getElement( 'month' + seg)[0].value == '') {
    month++;
  }

  getElement( 'month' + seg).selectedIndex = month;

  updateCalendar( seg);
}

// update the calendar
function updateCalendar( seg)
{
  var day0   = Number( getElement( 'day' + seg).value);
  var month0 = Number( getElement( 'month' + seg).value);

  var d         = new Date();
  var thisday   = d.getDate();
  var thismonth = d.getMonth() + 1;
  var year0     = d.getFullYear();

  if( month0 < thismonth) year0++;

  if( month0 == thismonth && day0 < thisday) {
    month0++;
    year0++;

    if( month0 > 12) {
      month0 -= 12;
    }

    getElement( 'month' + seg).selectedIndex = month0 - 1;
  }

  // get the number of days for outbound month
  stop = new Date( year0, month0, 0).getDate();

  if( day0 > stop) {
    day0 = stop;
    getElement( 'day' + seg).selectedIndex = day0 - 1;
  }

  var next = seg + 1;

  while( getElement( 'day' + next) &&
         getElement( 'day' + next).value != '' &&
         getElement( 'month' + next).value != '') {
    var day1   = Number( getElement( 'day' + next).value);
    var month1 = Number( getElement( 'month' + next).value);
    var year1  = d.getFullYear();

    if( month1 < thismonth) year1++;

    if( month1 == thismonth && day1 < thisday) {
      month1++;
      year1++;

      if( month1 > 12) {
        month1 -= 12;
      }

      getElement( 'month' + next).selectedIndex = month1 - 1;
    }

    // get the number of days for inbound month
    stop = new Date( year1, month1, 0).getDate();

    if( day1 > stop) {
      day1 = stop;

      if( getElement( 'day' + next)[0].value == '') {
        getElement( 'day' + next).selectedIndex = day1;
      } else {
        getElement( 'day' + next).selectedIndex = day1 - 1;
      }
    }

    // check if we have to update the other calendar
    var d0 = new Date( year0, month0 - 1, day0);
    var d1 = new Date( year1, month1 - 1, day1);

    if( d0 > d1) {
      day1   = day0;
      month1 = month0;
      year1  = year0;

      if( getElement( 'day' + next)[0].value == '') {
        getElement( 'day' + next).selectedIndex   = day1;
        getElement( 'month' + next).selectedIndex = month1;
      } else {
        getElement( 'day' + next).selectedIndex   = day1 - 1;
        getElement( 'month' + next).selectedIndex = month1 - 1;
      }
    }

    next++;
  }
}
