//TO DISABLE Recent Search Results - CHANGE var rsrEnabled = true; TO var rsrEnabled = false;
// this will stop the script from collecting data and adding it to cookies, as well as displaying it on the homepage.
var rsrEnabled = true;
//END TO DISABLE

var rsrLang,rsrCountry,rsrTrans;
String.prototype.trim = function() {return this.replace(/^[\s]+|[\s]+$/gi,'');};

// adds a property to the tracking object and runs the tracking function
function rsrTrack ( name, value ){
	trackingInfo[name] = value;
	$('#t-tracking-fragment').html( vsDoTracking() );
}	

function rsrGetMonth(month){
	return (typeof refSMonth !== 'undefined')?refSMonth[month-1]:month;
}
function rsrGetTranslations(){
	//function to read copy from hidden inputs and add them to a translations object
	var translations = {};
	$('input','#rsr_translations').each(function(i,element){
		if(element.value !== 'undefined'){
			translations[element.name.slice(4)] = element.value;
		}else{
			translations[element.name.slice(4)] = '';
		}
	});
	return translations;
}
function rsr_set_cookie(name,value,days,cookie) {
	//function to set cookie/localstorage
  var str,
      local = window.localStorage,
      date = new Date(),
      expiry;
  if (local && cookie !== true) {
		//set local storage
      local[name] = value;
  }
  else {
	//set cookie with expirary date
    if (typeof days === 'number') {
      date.setDate(date.getDate() + days);
      expiry = date.toUTCString();
      str = name.trim() +'='+ value.trim() +'; expires='+ expiry +'; path=/';
      document.cookie = str;
      return str;
    }
    else {
      str = name.trim() +'='+ value.trim() +'; path=/';
      document.cookie = str;
      return str;
    }
  }
}
function rsr_get_cookie(wanted_cookie, cookie) {
	//function to return raw cookie/localstorage data
  var i=0,
      local = window.localStorage,
      full_string = document.cookie,
      tmp_array,
      name,
      val,
      tmp,
      begin;

    if (local && cookie !== true) {
      return local[wanted_cookie];
    }
    else {
      if (full_string !== '' && typeof full_string !== 'undefined') {
        tmp_array = full_string.split(';');
        for (i;i<tmp_array.length;i+=1) {
          tmp = tmp_array[i];
          begin = tmp.indexOf('=');
          name = tmp.substr(0,begin).trim();
          val = tmp.substr(begin+1).trim();
          if (name === wanted_cookie) {return val;}
        }
      }
    }
    return false;
}
function rsr_delete_cookie(wanted_cookie, cookie) {
	//function to remove cookie/localstorage
  var local = window.localStorage;

    if (local && cookie !== true) {
      if (local[wanted_cookie] !== null) {
        local.removeItem(wanted_cookie);
        return true;
      }
      else {return false;}
    }
    else {
      rsr_set_cookie(wanted_cookie,'',-1,cookie);
      return true;
    }
}
function rsr_convert_date(unix,locale) {
	//takes unix time and returns dd/mm/yy or mm/dd/yy for us 
  var conversion;
  if (typeof unix === 'undefined' || typeof locale === 'undefined') {return false;}
  else {
    conversion = new Date((unix*1000));
    if (locale !== 'us') {return conversion.getDate() +'/'+ (conversion.getMonth()+1) +'/'+ (conversion.getFullYear()-2000);}
    else {return (conversion.getMonth()+1) +'/'+ conversion.getDate() +'/'+ (conversion.getFullYear()-2000);}
  }
}
function rsr_month_to_number(str) {
	//converts month name to month number. Used when collecting flight date info from the flightlist and calender 
  var i,rex;
  if (typeof str !== 'undefined') {
    rex = new RegExp(str,'i');
    for (i=0;i<=11;i+=1) {
      if (rex.test(refSMonth[i])) {return i;}
    }
  }
  return false;
}
function rsr_parse_string(cookie_string) {
	// takes a raw string and returns a nicely arranges object
  var i = 0,
      tmp_all,
      tmp_details,
      tmp_flights,
      tmp_segments,
      tmp_flight_details,
      tmp_flight_date,
      tmp_options,
      journey_details = [],
      count = 0;

      if (typeof cookie_string !== 'undefined' || cookie_string !== null) {
        tmp_all = (cookie_string.indexOf('||') !== false) ? cookie_string.split('||') : [cookie_string];
        //  This for loops iterates through each entry within the cookie string
        //  Entries are delimited by "||"
        //  Flights & options are delimited by "&&" with options always being the last entry
        //  Details of each flight are delimited by ","
        for (i=0;i<tmp_all.length;i+=1) {
          journey_details[count] = {};
          tmp_details = tmp_all[i].split('&&');
          tmp_options = tmp_details.pop().split(',');
          if (tmp_options.length !== 4) {return false;}
          else {
            journey_details[count].options = {};
            journey_details[count].options.adults = tmp_options[0];
            journey_details[count].options.children = tmp_options[1];
            journey_details[count].options.infants = tmp_options[2];
            journey_details[count].options.cabin = tmp_options[3];
          }

          if (tmp_details.length > 0) {
              tmp_flights = [];
              // Outbound journey
              tmp_segments = tmp_details[0].split(':');
              tmp_flight_details = tmp_segments[0].split(',');
              journey_details[count].outbound = {};
              journey_details[count].outbound.reference = tmp_flight_details[0];
              journey_details[count].outbound.depart = {};
              journey_details[count].outbound.depart.code = tmp_flight_details[1];
              journey_details[count].outbound.depart.name = tmp_flight_details[2];

              tmp_flight_date = tmp_flight_details[3].split('@');
              journey_details[count].outbound.depart.date = tmp_flight_date[0];
              journey_details[count].outbound.depart.time = tmp_flight_date[1];
              journey_details[count].outbound.depart.locale = tmp_flight_date[2];

              tmp_flight_details = tmp_segments[1].split(',');
              journey_details[count].outbound.arrival = {};
              journey_details[count].outbound.arrival.code = tmp_flight_details[0];
              journey_details[count].outbound.arrival.name = tmp_flight_details[1];

              tmp_flight_date = tmp_flight_details[2].split('@');
              journey_details[count].outbound.arrival.date = tmp_flight_date[0];
              journey_details[count].outbound.arrival.time = tmp_flight_date[1];
              journey_details[count].outbound.arrival.locale = tmp_flight_date[2];

              // Inbound journey if there is one
              if (tmp_details.length === 2) {
                tmp_segments = tmp_details[1].split(':');
                tmp_flight_details = tmp_segments[0].split(',');
                journey_details[count].inbound = {};
                journey_details[count].inbound.reference = tmp_flight_details[0];
                journey_details[count].inbound.depart = {};
                journey_details[count].inbound.depart.code = tmp_flight_details[1];
                journey_details[count].inbound.depart.name = tmp_flight_details[2];

                tmp_flight_date = tmp_flight_details[3].split('@');
                journey_details[count].inbound.depart.date = tmp_flight_date[0];
                journey_details[count].inbound.depart.time = tmp_flight_date[1];
                journey_details[count].inbound.depart.locale = tmp_flight_date[2];

                tmp_flight_details = tmp_segments[1].split(',');
                journey_details[count].inbound.arrival = {};
                journey_details[count].inbound.arrival.code = tmp_flight_details[0];
                journey_details[count].inbound.arrival.name = tmp_flight_details[1];

                tmp_flight_date = tmp_flight_details[2].split('@');
                journey_details[count].inbound.arrival.date = tmp_flight_date[0];
                journey_details[count].inbound.arrival.time = tmp_flight_date[1];
                journey_details[count].inbound.arrival.locale = tmp_flight_date[2];
              }
          }
          count += 1;
        }
        return journey_details;
      }
      else {return false;}
}
function rsr_rebuild_cookie(original) {
	//takes an object and converts it back into a raw string to be stored
  var i=0,
      len = original.length,
      final_string = '',
      tmp_conditional = '',
      tmp_string,
      parent;

      for (i=0;i<len;i+=1) {
        parent = original[i];
        tmp_string = '';
        tmp_string += parent.outbound.reference +',';
        tmp_string += parent.outbound.depart.code +','+ parent.outbound.depart.name +',';
        tmp_string += parent.outbound.depart.date +'@'+ parent.outbound.depart.time +'@'+ parent.outbound.depart.locale;
        tmp_string += ':';
         tmp_string += parent.outbound.arrival.code +','+ parent.outbound.arrival.name +',';
        tmp_string += parent.outbound.arrival.date +'@'+ parent.outbound.arrival.time +'@'+ parent.outbound.arrival.locale;

        if (typeof parent.inbound !== 'undefined') {
			//if there is inbound data
          tmp_string += '&&';
          tmp_string += parent.inbound.reference +',';
          tmp_string += parent.inbound.depart.code +','+ parent.inbound.depart.name +',';
          tmp_string += parent.inbound.depart.date +'@'+ parent.inbound.depart.time +'@'+ parent.inbound.depart.locale;
          tmp_string += ':';
          tmp_string += parent.inbound.arrival.code +','+ parent.inbound.arrival.name +',';
          tmp_string += parent.inbound.arrival.date +'@'+ parent.inbound.arrival.time +'@'+ parent.inbound.arrival.locale;
        }

        tmp_string += '&&';
        tmp_string += parent.options.adults +','+ parent.options.children +','+ parent.options.infants +','+ parent.options.cabin;

        tmp_conditional = (i !== (len-1)) ? '||' : '';
        tmp_string += tmp_conditional;
        final_string += tmp_string;
      }
      return final_string;
}
function rsr_unix_time(day,month,year) {
	//converts day,month,year into a unix time string
  if (typeof day === 'undefined') {return false;}
  else if (typeof month === 'undefined') {return false;}
  else if (typeof year === 'undefined') {return false;}
  return ~~((new Date(year,month,day).getTime())/1000);
}
function rsr_test_dates(flight,server) {
	// compares 2 time strings and returns true or false
  return (flight < server) ? false : true;
}
function rsrUpdateResultsCookie(){
	//function to join temp cookie data to the results cookie if data exists. Otherwise is seturns the state to show.
	//called on the homepage, complex plan, simple plan and change booking fragment on calender page
	var resultsCookie = rsr_get_cookie('RSR_RESULTS'),
		tempCookie = rsr_get_cookie('RSR_TEMP'),
		disabledCookie = rsr_get_cookie('RSR_DISABLED',true);
	if(disabledCookie === '1'){
		// if RSR is disabled dont do anything
		return false;
	}
	if((resultsCookie === false || resultsCookie === null || typeof resultsCookie === 'undefined') && (tempCookie === false || tempCookie === null || typeof tempCookie === 'undefined')){
		//there is no results cookie and no temp cookie (i.e. no search has been performed and we have no cookies)
		return 'blank';
	}

	//if temp cookie has data
	if(tempCookie !== false && tempCookie !== null && typeof tempCookie !== 'undefined'){
		if(resultsCookie === 'empty' || resultsCookie === false || resultsCookie === null || typeof resultsCookie === 'undefined'){
			resultsCookie = tempCookie;
		}else{
			resultsCookie = tempCookie + '||' + resultsCookie;
		}
		rsr_set_cookie('RSR_RESULTS',resultsCookie,365);
		rsr_delete_cookie('RSR_TEMP');
	}
	return resultsCookie;
}
function rsr_get_page_data() {
	//collects flight data from flight list and calendar and adds them to the temp_cookie
  var page = $('input[name="pageid"]', $('#t-page-info-fragment')).val(),
      locale = $('input[name="country"]', $('#t-page-info-fragment')).val(),
      tmp,
      data,
      parent = $('div#RSR', $('div#t-main-fragment')),
      departure_city = $('input#rsr_DepartureCity', parent).val(),
      departure_code = $('input#rsr_DepartureCode', parent).val(),
      departure_date = $('input#rsr_DepartureDate', parent).val().split('-'),
      arrival_city = $('input#rsr_DestinationCity', parent).val(),
      arrival_code = $('input#rsr_DestinationCode', parent).val(),
      return_date = $('input#rsr_ReturnDate', parent).val().split('-'),
      cabin = $('input#rsr_Cabin', parent).val(),
      adults = $('input#rsr_Adults', parent).val(),
      children = $('input#rsr_Children', parent).val(),
      infants = $('input#rsr_Infants', parent).val();

    if (rsr_get_cookie('RSR_DISABLED',true) === '1') {return false;}

    if (page === 'FSCALENDAR' || page === 'FSFLIGHTLIST' || page === 'FSCALENDARANDFLIGHTLIST') {
		//collect all the basic data we can
	  $('input#change', $('form#cys')).click(function() {
        rsrUpdateResultsCookie();
      });
      data = '**,';
      data += departure_code +','+ departure_city +',';
      tmp = departure_date;
      tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
      data += tmp + '@**@'+locale;
      data += ':';
      data += arrival_code +','+ arrival_city +',';
      data += '**@**@'+locale;
      tmp = return_date;
      if (tmp[0] !== '') {
        data += '&&';
        data += '**,';
        data += arrival_code +','+ arrival_city +',';
       // tmp = tmp.split('-');
        tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
        data += tmp + '@**@'+locale;
        data += ':';
        data += departure_code +','+ departure_city +',';
        data += '**@**@'+locale;
      }
      data += '&&';
      data += adults +','+ children +','+ infants +','+ cabin;

      if (page === 'FSFLIGHTLIST' || page === 'FSCALENDARANDFLIGHTLIST') {
		// when the continue button is clicked collect flight numbers and times as well
        $('input#continue', 'form#flightList').add('#redContinueButtonFlightsDoNotMatch','#airportDoNotMatch').click(function() {
		 var outbound_selected = $('div.cjHolderSelected', 'div#obJourneys'),
			inbound_selected = $('div.cjHolderSelected', 'div#ibJourneys'),
			outbound_ffs_parent = $('div#outBoundFlightList'),
			inbound_ffs_parent = $('div#inBoundFlightList'),
			extractedDepart,
			extractedArrive,
			tmp_month_name_depart,
			tmp_month_name_arrive,
			tmp_month_num,
			tmp_day_num,
			tmp_depart_time,
			tmp_depart_date_string,
			tmp_arrival_date_sting,
			tmp_arrival_time,
			tmp_day_num_arrive,
			tmp_depart_date,
			tmp_flight_code,
			extracted;
		 if (page === 'FSFLIGHTLIST') {
				// check that if inbound flights are available one is selected
				if ($('div#ibJourneys').length > 0 && inbound_selected.length === 0) {
					return;
				}
		  
                if (outbound_selected.length > 0) {
                  tmp_depart_time = outbound_selected.find('td.dep p');
                  tmp_arrival_time = outbound_selected.find('td.arr p');
                  tmp_flight_code = outbound_selected.find('td.oper p a.peripheralLink');
                  if (tmp_depart_time.length > 1) {
                    tmp_depart_time = outbound_selected.find('td.dep p strong').html();
                    tmp_arrival_time = outbound_selected.find('td.arr p strong').html();
                    tmp_flight_code = outbound_selected.find('td.oper:first p a.peripheralLink').html();
                  }
                  else {
                    if (tmp_depart_time.children('strong').length > 0) {tmp_depart_time = tmp_depart_time.children('strong').html();}
                    else {tmp_depart_time = tmp_depart_time.html();}
                    if (tmp_arrival_time.children('strong').length > 0) {tmp_arrival_time = tmp_arrival_time.children('strong').html();}
                    else {tmp_arrival_time = tmp_arrival_time.html();}
                    tmp_flight_code = tmp_flight_code.html();
                  }
                }
                else {
                  tmp_depart_time = '**';
                  tmp_arrival_time = '**';
                  tmp_flight_code = '**';
                }
                data = tmp_flight_code +',';
                data += departure_code +','+ departure_city +',';
                extracted = tmp_depart_time.split('&nbsp;');
                tmp_month_num = rsr_month_to_number(extracted[3]);
			  
                if (tmp_month_num !== '') {
                  tmp = departure_date;
                  tmp = rsr_unix_time(extracted[2],tmp_month_num,tmp[0]);
                  data += tmp +'@'+ extracted[0].replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
  
                data += ':';
                data += arrival_code +','+ arrival_city +',';
  
                extracted = tmp_arrival_time.split('&nbsp;');
                tmp_month_num = rsr_month_to_number(extracted[3]);
  
                if (tmp_month_num !== '') {
                  tmp = departure_date;
                  tmp = rsr_unix_time(extracted[2],tmp_month_num,tmp[0]);
                  data += tmp +'@'+ extracted[0].replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
  
                if (return_date[0] !== '') {
  
                  data += '&&';
                  if (inbound_selected.length > 0) {
                    tmp_depart_time = inbound_selected.find('td.dep p');
                    tmp_arrival_time = inbound_selected.find('td.arr p');
                    tmp_flight_code = inbound_selected.find('td.oper p a.peripheralLink');
                    if (tmp_depart_time.length > 1) {
                      tmp_depart_time = inbound_selected.find('td.dep p strong').html();
                      tmp_arrival_time = inbound_selected.find('td.arr p strong').html();
                      tmp_flight_code = inbound_selected.find('td.oper:first p a.peripheralLink').html();
                    }
                    else {
                      if (tmp_depart_time.children('strong').length > 0) {tmp_depart_time = tmp_depart_time.children('strong').html();}
                     else {tmp_depart_time = tmp_depart_time.html();}
                       if (tmp_arrival_time.children('strong').length > 0) {tmp_arrival_time = tmp_arrival_time.children('strong').html();}
                      else {tmp_arrival_time = tmp_arrival_time.html();}
                      tmp_flight_code = tmp_flight_code.html();
                    }
                  }
                  else {
                    tmp_depart_time = '**';
                    tmp_arrival_time = '**';
                    tmp_flight_code = '**';
                  }
  
                  data += tmp_flight_code + ',';
                  data += arrival_code +','+ arrival_city +',';
                  extracted = tmp_depart_time.split('&nbsp;');
                  tmp_month_num = rsr_month_to_number(extracted[3]);
				  
				  
                  if (tmp_month_num !== '') {
                    tmp = return_date;
                    tmp = rsr_unix_time(extracted[2],tmp_month_num,tmp[0]);
                    data += tmp +'@'+ extracted[0].replace(':','-') +'@'+ locale;
                  }
                  else {
                    tmp = return_date;
                    tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                    data += tmp + '@**@'+locale;
                  }

                  data += ':';
                  data += departure_code +','+ departure_city +',';
 
                  extracted = tmp_arrival_time.split('&nbsp;');
                  tmp_month_num = rsr_month_to_number(extracted[3]);
					
                  if (tmp_month_num !== '') {
                    tmp = return_date;
                    tmp = rsr_unix_time(extracted[2],tmp_month_num,tmp[0]);
                    data += tmp +'@'+ extracted[0].replace(':','-') +'@'+ locale;
                  }
                  else {
                    tmp = return_date;
                    tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                    data += tmp + '@**@'+locale;
                  }
                }
                data += '&&';
                data += adults +','+ children +','+ infants +','+ cabin;
                
            } else if(page === 'FSCALENDARANDFLIGHTLIST') {
				outbound_selected = $('td.selected', outbound_ffs_parent);
				inbound_selected = $('td.inSelected', inbound_ffs_parent);
				
				// check that if inbound flights are available one is selected
				if (inbound_ffs_parent.length > 0 && inbound_selected.length === 0) {
					return;
				}
				
				departure_date = $('tr:first span.FlightData span.depDate', '#outboundDates').html();
				departure_date = ['20'+departure_date.slice(4,6),departure_date.slice(2,4),departure_date.slice(0,2)];
				if(return_date[0] !== '' ){
					return_date = $('tr:first span.FlightData span.depDate', '#inboundDates').html();
					return_date = ['20'+return_date.slice(4,6),return_date.slice(2,4),return_date.slice(0,2)];
				}
				
				 
				
			    if (outbound_selected.length > 0) {
                  tmp_depart_time = outbound_selected.eq(0).find('span.time').html().trim();
				  tmp_depart_date_string = outbound_selected.eq(0).find('span.date').html().trim();
				  tmp_depart_date = (outbound_selected.parent().find('span.FlightData span.depDate').html() || outbound_selected.parent().prev().find('span.FlightData span.depDate').html()).trim(); //ddmmyy 
                  tmp_arrival_time = outbound_selected.eq(1).find('span.time').html().trim();
				  tmp_arrival_date_sting = outbound_selected.eq(1).find('span.date').html().trim();
				  tmp_flight_code = outbound_selected.parent().find('span.FlightData span.Carrier').html() + outbound_selected.parent().find('span.FlightData span.FlightNumber').html();
			   }
                else {
                  tmp_depart_time = '**';
                  tmp_arrival_time = '**';
                  tmp_flight_code = '**';
                }
				
                data = tmp_flight_code +',';
                data += departure_code +','+ departure_city +',';
				extractedDepart = tmp_depart_date_string.split(' ');
                tmp_month_name_depart = extractedDepart[1];
                tmp_month_num = Number(tmp_depart_date.slice(2,4));
				tmp_day_num = Number(tmp_depart_date.slice(0,2));
			  
				
			  
                if (tmp_month_num !== '') {
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp_day_num,tmp_month_num-1,tmp[0]);
				  
                  data += tmp +'@'+ tmp_depart_time.replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
  
                data += ':';
                data += arrival_code +','+ arrival_city +',';
  
                extractedArrive = tmp_arrival_date_sting.split(' ');
				tmp_day_num_arrive = extractedArrive[0];
                tmp_month_name_arrive = extractedArrive[1];
				
				
  
                if (tmp_day_num_arrive !== '') {
				  //if month names are different, the arrival month needs to go forwards or back 1
				  if(tmp_month_name_depart !== tmp_month_name_arrive) {
				    if(tmp_day_num_arrive > tmp_day_num){
					  // we have gone back a month
					  tmp_month_num = tmp_month_num -1;
				      if(tmp_month_num === 0){
					    tmp_month_num = 12;
				      }
				    }else{
					  //we have gone forwards a month
					  tmp_month_num = tmp_month_num +1;
				      if(tmp_month_num === 13){
					    tmp_month_num = 1;
				      }
				    }
				  }
					
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp_day_num_arrive,tmp_month_num-1,tmp[0]);
				  
                  data += tmp +'@'+ tmp_arrival_time.replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = departure_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
				
				
                if (return_date[0] !== '') {
                  data += '&&';
                  if (inbound_selected.length > 0) {
					tmp_depart_time = inbound_selected.eq(0).find('span.time').html().trim();
				    tmp_depart_date_string = inbound_selected.eq(0).find('span.date').html().trim();
					tmp_depart_date = (inbound_selected.parent().find('span.FlightData span.depDate').html() || inbound_selected.parent().prev().find('span.FlightData span.depDate').html()).trim(); //ddmmyy 
                    tmp_arrival_time = inbound_selected.eq(1).find('span.time').html().trim();
					tmp_arrival_date_sting = inbound_selected.eq(1).find('span.date').html().trim();
				    tmp_flight_code = inbound_selected.parent().find('span.FlightData span.Carrier').html() + inbound_selected.parent().find('span.FlightData span.FlightNumber').html();
				  }
                  else {
                    tmp_depart_time = '**';
                    tmp_arrival_time = '**';
                    tmp_flight_code = '**';
                  }
  
                  
				  data += tmp_flight_code +',';
                  data += arrival_code +','+ arrival_city +',';
				  extractedDepart = tmp_depart_date_string.split(' ');
                  tmp_month_name_depart = extractedDepart[1];
                  tmp_month_num = Number(tmp_depart_date.slice(2,4));
				  tmp_day_num = Number(tmp_depart_date.slice(0,2));
				  
				 
				  
                  if (tmp_month_num !== '') {
                  tmp = return_date;
                  tmp = rsr_unix_time(tmp_day_num,tmp_month_num-1,tmp[0]);
				   
                  data += tmp +'@'+ tmp_depart_time.replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = return_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
  
                data += ':';
                data += departure_code +','+ departure_city +',';
  
                extractedArrive = tmp_arrival_date_sting.split(' ');
				tmp_day_num_arrive = extractedArrive[0];
                tmp_month_name_arrive = extractedArrive[1];
				
				
  
                if (tmp_month_num !== '') {
				  //if month names are different, the arrival month needs to go forwards or back 1
				  if(tmp_month_name_depart !== tmp_month_name_arrive) {
				    if(tmp_day_num_arrive > tmp_day_num){
					// we have gone back a month
					  tmp_month_num = tmp_month_num -1;
				      if(tmp_month_num === 0){
					    tmp_month_num = 12;
				      }
				    }else{
					  //we have gone forwards a month
					  tmp_month_num = tmp_month_num +1;
				      if(tmp_month_num === 13){
					    tmp_month_num = 1;
				      }
				    }
				  }
                  tmp = return_date;
                  tmp = rsr_unix_time(tmp_day_num_arrive,tmp_month_num-1,tmp[0]);
				  
                  data += tmp +'@'+ tmp_arrival_time.replace(':','-') +'@'+ locale;
                }
                else {
                  tmp = return_date;
                  tmp = rsr_unix_time(tmp[2],Number(tmp[1])-1,tmp[0]);
                  data += tmp + '@**@'+locale;
                }
			  }
              data += '&&';
              data += adults +','+ children +','+ infants +','+ cabin;
			}
			rsr_set_cookie('RSR_TEMP',data,365);
            return data;
		  });
		  
        }
		rsr_set_cookie('RSR_TEMP',data,365);
        return data;
	  }
    return false;
}
function rsrFormatTime(time){
	//format the stored time to be displayed
	return time.split('-').join(':');
}
function rsrFormatDate(unix){
	// format the stored date into a nice string to display, depending in US or non-US
	var date, dateParts;
	date = rsr_convert_date(unix,rsrCountry);
	dateParts = date.split('/');
	if(rsrCountry !== 'us'){
		dateParts[1] = rsrGetMonth(dateParts[1]);
	}else{
		dateParts[0] = rsrGetMonth(dateParts[0]);
	}
	dateParts[2] = '20'+ dateParts[2];
	return dateParts.join(' ');
}

////////////////////////////////////////////////////////////////////////////////
// Close any open flight details
////////////////////////////////////////////////////////////////////////////////
function rsrCloseAll() {
	$('.rsr' /*, '#rsr_container'*/).removeClass('rsrActive');
	$('.rsrInfoActive' /*, '#rsr_container'*/).removeClass('rsrInfoActive');
	$('.rsrPopup' /*, '#rsr_container'*/).hide();
//	$('html').unbind('click.rsr');
}

function rsrRemoveFlight(rsrToDeleteNum){
	//remove result from our object and rebuild and set cookie
	var cookie = rsr_parse_string(rsr_get_cookie('RSR_RESULTS'));
	cookie.splice(rsrToDeleteNum,1);
	rsr_set_cookie('RSR_RESULTS',rsr_rebuild_cookie(cookie),365);
}
function rsrFlightTimeValid(data){
	//compare the flight departure date to the current serter time. Both compared in unix format 
	var rsrUnixServerDateTime = new Date(rsrTrans.server_time),
		rsrUnixServerDate;
	rsrUnixServerDate = rsr_unix_time(rsrUnixServerDateTime.getDate(),rsrUnixServerDateTime.getMonth(),rsrUnixServerDateTime.getFullYear());
	return (data.outbound.depart.date === rsrUnixServerDate)? false : rsr_test_dates(data.outbound.depart.date,rsrUnixServerDate);
}
function rsrIsDuplicate(resultsToPrint,index){
	// check if this result is a duplicate of another result.
	var x,
		tmp = resultsToPrint.slice(),
		current = tmp[index];
	tmp[index] = false;
	for(x in tmp){
		if (typeof tmp[x] !== 'undefined' && tmp[x] !== false) {
			if(tmp[x].hash === current.hash){
				if(tmp[x].type ==='full' && current.type ==='basic'){
					//the current result is a duplicate of this full detail search result
					return true; //this is a duplicate
				}else if(tmp[x].type ==='basic' && current.type ==='full'){
					//the current result is a better version of this result
					return x;
				}else{
					// both results are of the same type so are considered duplicates
					return true; //this is a duplicate
				}
			}
		}
	}
	return false;//this is not a duplicate
}








////////////////////////////////////////////////////////////////////////////////
// ALL PRESENTATIONAL CODE BELOW HERE
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// builds all the html markup for an individual flight
////////////////////////////////////////////////////////////////////////////////
function rsrAddRsr(rsrData){
	//adds an invidual RSR result to the html to be added to the page.
	var rsrHaveTimes = true,
		rsrReturn = true,
		rsrPaxMixArray =[],
		rsrPaxMix,
		rsrUrl, // deeplink url
		rsrTable, // used in the expanded flight details
		rsrDiv;
		
	if(rsrData.outbound.depart.time === '**') {
			rsrHaveTimes = false;
	}
	
	if(typeof rsrData.inbound === 'undefined') {
		rsrReturn = false;
	}
	
	if(rsrData.options.adults !== '0') {
		rsrPaxMixArray.push(rsrData.options.adults + ((rsrData.options.adults > 1)?' ' + rsrTrans.adults:' ' + rsrTrans.adult));
	}
	
	if(rsrData.options.children !== '0') {
		rsrPaxMixArray.push(rsrData.options.children + ((rsrData.options.children >1)?' '+ rsrTrans.children:' '+ rsrTrans.child));
	}
	
	if(rsrData.options.infants !== '0') {
		rsrPaxMixArray.push(rsrData.options.infants + ((rsrData.options.infants >1)?' '+ rsrTrans.infants:' '+ rsrTrans.infant));
	}
	
	rsrPaxMix = rsrPaxMixArray.join(' - '); // builds the pax mix string, only showing relevant categories, in plural if need be.
	
	rsrUrl = '/main/fx?source=rsrHomepage&eId=111009&ad=' + rsrData.options.adults + 
			 '&ch=' + rsrData.options.children +
			 '&inf=' + rsrData.options.infants +
			 '&cabin=' + rsrData.options.cabin +
			 '&to=' + ((rsrData.outbound.arrival.code.length === 6)? rsrData.outbound.arrival.code.substr(3,3) : rsrData.outbound.arrival.code) +
			 '&from='+ ((rsrData.outbound.depart.code.length === 6)? rsrData.outbound.depart.code.substr(3,3) :rsrData.outbound.depart.code) +
			 '&depDate='+ rsr_convert_date(rsrData.outbound.depart.date,rsrCountry);
	
	if(rsrReturn === true) { //return flight
		if(rsrHaveTimes === true) { //full details
			rsrTable = '<tr><td colspan="3" class="rsrRoute">'+ 
					   rsrData.outbound.depart.name + ' - '+ 
					   rsrData.outbound.arrival.name +
					   '</td></tr><tr><td rowspan="2" class="rsrPlaneOut"></td><td class="rsrPart">' + 
					   rsrTrans.departs +
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.outbound.depart.time) + ' - ' + 
					   rsrFormatDate(rsrData.outbound.depart.date) +
					   '</td></tr><tr class="rsrLine"><td class="rsrPart">' + 
					   rsrTrans.arrives +
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.outbound.arrival.time) + ' - ' + 
					   rsrFormatDate(rsrData.outbound.arrival.date) + 
					   '</td></tr><tr><td colspan="3" class="rsrRoute">' + 
					   rsrData.inbound.depart.name + ' - ' + 
					   rsrData.inbound.arrival.name +
					   '</td></tr><tr><td rowspan="2" class="rsrPlaneIn"></td><td class="rsrPart">' + 
					   rsrTrans.departs + 
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.inbound.depart.time) + ' - ' + 
					   rsrFormatDate(rsrData.inbound.depart.date) + 
					   '</td></tr><tr class="rsrLine"><td class="rsrPart">' + 
					   rsrTrans.arrives + 
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.inbound.arrival.time) + ' - ' + 
					   rsrFormatDate(rsrData.inbound.arrival.date) + 
					   '</td></tr><tr><td></td><td colspan="2" class="rsrPax">' + 
					   rsrPaxMix +
					   '</td></tr><tr class="rsrLine"><td></td><td colspan="2">' + 
					   rsrTrans[rsrData.options.cabin] + 
					   '</td></tr>';
			rsrUrl += '&retDate=' + 
					  rsr_convert_date(rsrData.inbound.depart.date, rsrCountry) +
					  '&myDatesAreFixedSelected=true';
		}
		
		else { //basic details
			rsrTable = '<tr><td colspan="3" class="rsrRoute">' + 
					   rsrData.outbound.depart.name + ' - ' + 
					   rsrData.outbound.arrival.name + '</td></tr><tr class="rsrLine"><td class="rsrPlaneOut"></td><td class="rsrPart">' + 
					   rsrTrans.departs +
					   '</td><td>' + 
					   rsrFormatDate(rsrData.outbound.depart.date) +
					   '</td></tr><td colspan="3" class="rsrRoute">' + 
					   rsrData.inbound.depart.name + ' - ' + 
					   rsrData.inbound.arrival.name + 
					   '</td></tr><tr class="rsrLine"><td class="rsrPlaneIn"></td><td class="rsrPart">' + 
					   rsrTrans.departs +'</td><td>' + 
					   rsrFormatDate(rsrData.inbound.depart.date) +
					   '</td></tr><tr><td></td><td colspan="2" class="rsrPax">' + 
					   rsrPaxMix +
					   '</td></tr><tr class="rsrLine"><td></td><td colspan="2">' + 
					   rsrTrans[rsrData.options.cabin] +
					   '</td></tr>';
			rsrUrl += '&retDate=' + rsr_convert_date(rsrData.inbound.depart.date, rsrCountry);
		}
	}
	
	else { //one way
		if(rsrHaveTimes === true) { //full details
			rsrTable = '<tr><td colspan="3" class="rsrRoute">' + 
					   rsrData.outbound.depart.name + ' - ' + 
					   rsrData.outbound.arrival.name + 
					   '</td></tr><tr><td rowspan="2" class="rsrPlaneOut"></td><td class="rsrPart">' + 
					   rsrTrans.departs + 
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.outbound.depart.time) + ' - ' + 
					   rsrFormatDate(rsrData.outbound.depart.date) + 
					   '</td></tr><tr class="rsrLine"><td class="rsrPart">' + 
					   rsrTrans.arrives +
					   '</td><td class="rsrTime">' + 
					   rsrFormatTime(rsrData.outbound.arrival.time) + ' - ' + 
					   rsrFormatDate(rsrData.outbound.arrival.date) +
					   '</td></tr><tr><td></td><td colspan="2" class="rsrPax">' + 
					   rsrPaxMix +
					   '</td></tr><tr class="rsrLine"><td></td><td colspan="2">' + 
					   rsrTrans[rsrData.options.cabin] + 
					   '</td></tr>';
			rsrUrl += '&myDatesAreFixedSelected=true';
		}
		
		else { //basic details
			rsrTable = '<tr><td colspan="3" class="rsrRoute">' + 
					   rsrData.outbound.depart.name + ' - ' + 
					   rsrData.outbound.arrival.name +
					   '</td></tr><tr class="rsrLine"><td class="rsrPlaneOut"></td><td class="rsrPart">' + 
					   rsrTrans.departs +
					   '</td><td>' + 
					   rsrFormatDate(rsrData.outbound.depart.date) +
					   '</td></tr><tr><td></td><td colspan="2" class="rsrPax">' + 
					   rsrPaxMix +
					   '</td></tr><tr class="rsrLine"><td></td><td colspan="2">' + 
					   rsrTrans[rsrData.options.cabin] +
					   '</td></tr>';
		}
	}
	
	// most of the rsr_div including the deeplinks and the rsrTable
	rsrDiv = '<div class="rsr">' +
			 	'<div class="rsrIcons">' +
			 		'<a href="#" title="' + 
			 			rsrTrans.clearAltTag +
			 			'" class="rsrDelete">&nbsp;</a>' +
			 		'<a href="#" title="' + 
			 			rsrTrans.detailsAltTag +
			 			'" class="rsrInfo">&nbsp;</a>' +
				'</div>' +
				'<div class="button primary"><a href="' + rsrUrl + '">' +
				rsrTrans.findFlights +
				'</a></div>' +
				'<a class="tertiaryLink rsrSearch" href="' + rsrUrl + '">' + 
			 		rsrData.outbound.depart.name + ' - ' + 
			 		rsrData.outbound.arrival.name +
			 		'</a>' +
			   '<p>' + rsrFormatDate(rsrData.outbound.depart.date); 
	
	// If applicable, add the return date 
	if(rsrReturn === true) {
		rsrDiv += ' - ' + rsrFormatDate(rsrData.inbound.depart.date);
	}
	
	rsrDiv += '</p>';
	
	// Add detailed info that is hidden by default but used to 
	// populate a popup if user requests more info
	rsrDiv += '<div class="rsrPopup">' +
					'<span class="rsrCurrentActive"></span>' +
					'<div class="rsrPopupBg">' +
						'<div class="rsrPopupInner">' +
							'<span class="rsrClose"></span>' +
//							'<h4>' + 
//								rsrTrans.searchDetails +
//								'</h4>' +
							'<table><tbody>' + 
								rsrTable + 
								'</tbody></table>' +
							'<div class="button secondary rsrSearch">' +
								'<a href="' + 
									rsrUrl + '">' + 
									rsrTrans.search +
									'</a>' +
							'</div>' +
							'<div class="clearBoth"></div>' +
						'</div>' +
					'</div>' +
//					'<div class="rsrPopupBottom">&nbsp;</div>' +
				'</div>';
				
	// Close the rsr div
	rsrDiv += '</div>';

	return rsrDiv;
}

////////////////////////////////////////////////////////////////////////////////
// shows a modal over the top of the clicked link asking the user to confirm
// their 'Clear' action
////////////////////////////////////////////////////////////////////////////////
function rsrShowClearModal(type){
		//shows the 'clear all' or 'disable RSR' question and buttons
	var pHeight;
	
	if(type === 'clear') {
		$('span.rsrQuestion','#rsrClearModal').text(rsrTrans.clearQuestion);
	}
	
	else {
		$('span.rsrQuestion','#rsrClearModal').text(rsrTrans.disableQuestion);
	}
	
	$('#rsrClearModal').fadeIn(700);
	
	if($('#rsrClearAll').length === 0){
		$('p','#rsrClearModal').css({'padding-top':0});
		
		// If the p tag is higher than the rsrButtonsArea, make the buttons area bigger to fit them in
		pHeight = $('#rsrClearModal p').height();
		
		if(($('#rsrButtonsArea').height() -3) < pHeight) {
			$('#rsrButtonsArea').css({'height':pHeight});
		}
	}
	
	// Add click function to 'Yes' link, action depends on whether its 'clear' or 'disable'
	$('#rsrClearYes').click(function(event) {
		event.preventDefault();

		if(type === 'clear'){
			rsr_set_cookie('RSR_RESULTS','empty',365);
		
			$('#recentSearches').empty();
			
			rsrTrack( 'interaction', 'rsrHomepageClearAll' )// track this event
			
			rsrLoad();
		}
		
		else{
			rsr_delete_cookie('RSR_RESULTS');
			
			rsr_delete_cookie('RSR_TEMP');
			
			rsr_set_cookie('RSR_DISABLED','1',365, true);
			
			$('#recentSearches').empty();
			
			rsrTrack( 'interaction', 'rsrHomepageDisable' )// track this event
			
			rsrLoad();
		}
	});
}

////////////////////////////////////////////////////////////////////////////////
// shows a modal over the top of the clicked link asking the user to confirm 
// their 'Delete' action
////////////////////////////////////////////////////////////////////////////////
function rsrShowDeleteModal(rsr){
	//shows the 'delete' question and buttons for an individual result
	var divHeight, divWidth;
	
	$('.rsrDeleteModal','#recentSearches').hide();
	
	if($('.rsrDeleteModal', rsr).length > 0) { //there is already a model div to show
		$('.rsrDeleteModal',rsr).fadeIn(700);
	}
	
	else { //build a new div
		$(rsr).css('cursor','default');
		divHeight = rsr.innerHeight() - 4;
		divWidth = rsr.innerWidth() - 3;
		rsr.append('<div class="rsrDeleteModal" style="display:none;' +
//				   'width:' + divWidth + 'px;' +
//				   'height:' + divHeight + 'px;' +
				   '"><p>' + 
				   rsrTrans.deleteQuestion +
				   ' <span class="nobreak"><a href="#" class="rsrDeleteYes">' + 
				   rsrTrans.yes +
				   '</a> <a href="#" class="rsrDeleteNo">' + 
				   rsrTrans.no + 
				   '</a></span></p></div>');
		
		$('.rsrDeleteModal', rsr).fadeIn(700);
	}
	
	// add click handlers
	$('.rsrDeleteNo',rsr).click(function (event){
		event.preventDefault();
		
		$('.rsrDeleteModal','#recentSearches').fadeOut(700);

		rsrCloseAll();
	});
	
	// user clicked yes
	$('.rsrDeleteYes',rsr).click(function (event){
		event.preventDefault();
		
		rsrRemoveFlight($(rsr).prevAll('.rsr').length);
		
		$(rsr).remove();
		
		rsrTrack( 'interaction', 'rsrHomepageClearOne' )// track this event
		
		// If this was the last result deleted
		if($('.rsr','#recentSearches').length < 1) {
			rsr_set_cookie('RSR_RESULTS','empty',365);
			$('#recentSearches').empty();
			rsrLoad();
		}
		
		else {
			// Change classNames quickly to force IE 6 to redraw elements properly
			$('.rsr','#recentSearches').addClass('x').removeClass('x');
		}
	});
}

////////////////////////////////////////////////////////////////////////////////
// fires on dom ready on home page
////////////////////////////////////////////////////////////////////////////////
function rsrLoad() {
	// This function is called first on the homepage and controls the display
	// of the RSR fragment
	var disabled = rsr_get_cookie('RSR_DISABLED', true),
		resultsCookie = rsrUpdateResultsCookie(),
		rsrHtml = '',
		data,
		count = 0,
		x,
		i,
		rsrButtonsArea,
		isDuplicate,
		printed = [],
		resultsToPrint = [];
	
	rsrLang = $('input[name="language"]', '#pageMetaData').val();
	rsrCountry = $('input[name="country"]', '#pageMetaData').val();
	rsrTrans = rsrGetTranslations(); //gets all translations to be used
	
	if(resultsCookie === 'blank'){ 
		// show nothing as the user has never made a search yet
		// the rsr link on the plan trip fragment remains hidden
		return false;
	}
	
	// If we get this far we have some data to play with, so enable
	// the 'Recent search results' button on the plan fragment
	$("#flightsContainer #showRecentSearches").removeClass("disabled");
	
	// Start building the html
//	rsrHtml += '<h3>'+ rsrTrans.title +'</h3>';
	
	if(disabled === '1') {
		// build disabled view
		rsrHtml += '<div class="hr">&nbsp;</div><div id="rsrButtonsArea"><a href="#" class="tertiaryLink" id="rsrEnable">' + 
				   rsrTrans.enableButton +
				   '</a><div class="clearBoth"></div></div>';
	}
	
	else if(resultsCookie !== 'empty') {	
		// Get results and check for expired and duplicate results, then prepare for display
		data = rsr_parse_string(resultsCookie);
		
		for(i=0; i<data.length; i++) {
			// Check flight departs in the future
			if(rsrFlightTimeValid(data[i]) === true) {
				// Check this is not a duplicate that has already been printed
				resultsToPrint[count] = {};
				resultsToPrint[count].data = data[i];
				resultsToPrint[count].type = ((data[i].outbound.depart.time === '**')? 'basic' : 'full');
				resultsToPrint[count].hash = data[i].options.cabin + data[i].options.adults + data[i].options.children + data[i].options.infants + data[i].outbound.depart.code + data[i].outbound.depart.date +data[i].outbound.arrival.code;
		
				if(typeof data[i].inbound !== 'undefined') {
					resultsToPrint[count].hash += data[i].inbound.depart.code + data[i].inbound.depart.date +data[i].inbound.arrival.code;
				}
				
				isDuplicate = rsrIsDuplicate(resultsToPrint,count);
				
				if(isDuplicate === false){
					count = count+1;
				}
				
				else if(isDuplicate !== true){
					//isDuplicate is a number so replace a previous result with this one
					resultsToPrint[isDuplicate] = resultsToPrint[count];
				}
			}
		}
		
		// If there are any cookie entries that are good to print build the content for each
		// all results may have been deleted at this stage due to expiry etc.
		if(count > 0){
			for(x=0;x<count;x++){
				if(resultsToPrint[x] !== 'null'){
					// Get the html content for each result
					resultsToPrint[x].content = rsrAddRsr(resultsToPrint[x].data);
					printed[x] = resultsToPrint[x].data;
				}
				
				// We only print up to 5 results
				if(printed.length === 5){
					break;
				}
			}
			
			// Save our used printed results back to the cookie for future use,
			// this will remove extra un-needed results
			rsr_set_cookie('RSR_RESULTS', rsr_rebuild_cookie(printed), 365);
			
			for(x = 0; x < count; x++) {
				if(typeof resultsToPrint[x].content !== 'undefined') {
					//join all html parts together
					rsrHtml += resultsToPrint[x].content;
				}
			}
			
			// 'Clear' & 'Disable' buttons
			rsrHtml += '<span id="rsr_bottom_image"></span>' +
					   '<div id="rsrButtonsArea">' +
							// Hidden 'confirmation' content
					   		'<div id="rsrClearModal" style="display:none;">' +
					   			'<p><span class="rsrQuestion">&nbsp;</span> ' +
					   				'<span class="nobreak">' +
					   					'<a href="#" id="rsrClearYes">' + rsrTrans.yes + '</a> ' +
					   					'<a href="#" id="rsrClearNo">' + rsrTrans.no + '</a>' +
					   				'</span>' +
					   			'</p>' +
							'</div>';
					   
			// 'Clear all' button
			rsrHtml += '<div id="rsrClearAll" class="button secondary">' +
					   		'<span>' + rsrTrans.clearButton + '</span>' +
					   '</div>' +
					   '<div class="clearBoth"></div>';
			
			// 'Disable search history' button
			rsrHtml += '<div id="rsrDisable" class="button tertiary">' +
							'<a href="#">' + rsrTrans.disableButton + '</a>' +
					   '</div>' +
					   '<div class="clearBoth"></div>' +
					   '</div>'; // End div#rsrButtonsArea
		}
		
		else {
			// There are no searches to display so force the display of the empty state
			rsr_set_cookie('RSR_RESULTS', 'empty', 365);
			resultsCookie = 'empty';
		}
		
	} // End else NOT dissabled, and (results cookie is NOT empty)
	
	if(resultsCookie === 'empty') {
		// Show empty state
		rsrHtml += '<p id="rsrEmptyMessage">' + rsrTrans.emptyNotice + '</p>' +
//				   '<div class="hr">&nbsp;</div>' +
				   '<div id="rsrButtonsArea"><div id="rsrClearModal" style="display:none;"><p><span class="rsrQuestion">&nbsp;</span> <span class="nobreak"><a href="#" id="rsrClearYes">' + 
				   rsrTrans.yes +
				   '</a> <a href="#" id="rsrClearNo">' + 
				   rsrTrans.no +
				   '</a></span></p></div><a href="#" class="tertiaryLink" id="rsrDisable">' + 
				   rsrTrans.disableButton +
				   '</a><div class="clearBoth"></div></div>';
	}
	
	// just check that the #recentSearches div exists
	if($('#recentSearches').length > 0) {	
		
		// Show the hidden rsr link on the plan fragment
		$('#showRecentSearches').show();
		
		// Add html to dom	
		$('#recentSearches').prepend(rsrHtml);
		
		//add event handlers	

		////////////////////////////////////////////////////////////////////////
		// add hover class to delete icon
		////////////////////////////////////////////////////////////////////////
		$('.rsrDelete', '#recentSearches').hover(function() {
			$(this).addClass('rsrDeleteHover');
		}, function() {
			$(this).removeClass('rsrDeleteHover');
		});
		
		////////////////////////////////////////////////////////////////////////
		// Add hover class to info icon
		////////////////////////////////////////////////////////////////////////
		$('.rsrInfo', '#recentSearches').hover(function (){
			$(this).addClass('rsrInfoHover');
		}, function (){
			$(this).removeClass('rsrInfoHover');
		});
		
		////////////////////////////////////////////////////////////////////////
		// Handle click on the 'Info' icon for a given search
		////////////////////////////////////////////////////////////////////////
		$('.rsrInfo', '#recentSearches').click(function (event){

			event.preventDefault();

			var popup, rsr, alreadyOpen;
			
			// Get the details of the selected search ready to be copied into the detail modal
			popup = $(".rsrPopup", $(this).closest('.rsr'));
			
			alreadyOpen = $(popup).is(':visible');
			
			// Hide any pending 'Confirm delete' prompts 
			$('.rsrDeleteModal', '#recentSearches').remove();
			
			rsrCloseAll();
			
			if(alreadyOpen === false) {
				$(this).addClass('rsrInfoActive');
				
				rsr = $(this).closest('.rsr');
				
				$(rsr).addClass('rsrActive');
				
				 popup.show();
				
//				$('html').bind('click.rsr', function (event) {
//					if($(event.target).closest('.rsrPopup').length === 0 && !$(event.target).hasClass('rsrInfo')) {
//						rsrCloseAll();
//					}
//				});
				
				rsrTrack( 'interaction', 'rsrHomepageOpenFlight' ) // track this event
			}
		});
		
		////////////////////////////////////////////////////////////////////////
		// Handle click events on 'Delete' icons
		////////////////////////////////////////////////////////////////////////
		$('.rsrDelete', '#recentSearches').click(function(event){
			event.preventDefault();
			
			// Close any detail popup and reset statuses
			rsrCloseAll();
			
			var rsr = $(this).closest('.rsr');
				
			// Set current item status to 'active'
			$(rsr).addClass('rsrActive');
			
			// Show the 'Confirm deletion' prompt
			rsrShowDeleteModal(rsr);
		});
		
		////////////////////////////////////////////////////////////////////////
		// close the expanded flight details
		////////////////////////////////////////////////////////////////////////
		$('.rsrClose'/*,'#recentSearches'*/).click(function() {
			rsrCloseAll();
		});
		
		////////////////////////////////////////////////////////////////////////
		// when the clear all link is clicked show the yes/no modal
		////////////////////////////////////////////////////////////////////////
		$('#rsrClearAll').click(function (){
			rsrShowClearModal('clear');
		});
		
		////////////////////////////////////////////////////////////////////////
		// when the disable link is clicked show the yes/no modal
		////////////////////////////////////////////////////////////////////////
		$('#rsrDisable').click(function (event){
			event.preventDefault();
			rsrShowClearModal('disable');
		});
		
		////////////////////////////////////////////////////////////////////////
		// when the Enable link is clicked reset the rsr fragment
		////////////////////////////////////////////////////////////////////////
		$('#rsrEnable').click(function (event){
			event.preventDefault();
			rsr_delete_cookie('RSR_DISABLED',true);
			rsr_set_cookie('RSR_RESULTS','empty',365);
			$('#recentSearches').empty();
			rsrTrack( 'interaction', 'rsrHomepageEnable' )// track this event
			rsrLoad();
		});
		
		////////////////////////////////////////////////////////////////////////
		// when one of the 'No' links is clicked hide the modal
		////////////////////////////////////////////////////////////////////////
		$('#rsrClearNo').click(function (event){
			event.preventDefault();
			$('#rsrClearModal').fadeOut(700);
			$('#rsrButtonsArea').css({'height':'auto'});
		});
		
	} // End if(we have at least one 'recentSearches')
}

////////////////////////////////////////////////////////////////////////////////
// the below code fires off the relevant domready event
////////////////////////////////////////////////////////////////////////////////
if(rsrEnabled === true){
	$(document).ready(function (){
		//kick off the correct functions depending on pageId
		if($('input[name="pageid"]', '#pageMetaData').val() === 'HOME'){
			rsrLoad();
		}else if($('input[name="pageid"]', '#t-page-info-fragment').val() === 'PLANTRIP'){
			rsrUpdateResultsCookie();
		}else if($('input[name="pageid"]', '#t-page-info-fragment').val() === 'COMPJRNY'){
			rsrUpdateResultsCookie();
		}else{
			rsr_get_page_data();
		}
	});
}