// Configuration
//keywords are words used for creating id and classes of elements generated 
keywords = {
    "country": "country",
    "content": "content",
    "group": "group",
    "separator": "-",
    "page": "page",
    "control": "control",
    "first": "first",
    "last": "last",
    "pagenum": "pagenum",
	"belgium":"Belgium"
}
// structure are elements already existing in the iframe document.
structure = {
    "tabs": "ul#tabs",
    "body": "#destinations",
    "popular": "popular",
	"belgium":"belgium-content"
}
layout = {
    "columns": 3,
    "items": 10,
    "first": "|&lt&lt;",
    "previous": "&lt;",
    "next": "&gt;",
    "last": "&gt;&gt;|"
}
	if (typeof(defaultBelgiumTab)!="boolean") 
	 {
	var defaultBelgiumTab= false;
		};
var popularTab;
/**
 * Le composant global.
 *
 * Composant IHM : Tabbox
 *
 * @param {Object} el
 * @param {Object} opt
 * 					- [Array] data	Liste des pays rcupres via JSON
 */
function PopupViewall(/* HTMLInputElement */el, /* Object */ opt){
    var s = this;
    this.el = el;
    this.opt = opt;
    
    // Container DOM pour les onglets
    // /* JQuery */ this.domTabs;
    
    // Container DOM pour les panneaux
    // /* JQuery */ this.domPanels;
    
    // Liste des pays
    /* Array<Object> */
    this.items = [];
    this.init();
}

PopupViewall.prototype = {
    /**
     * Initialisation du composant.
     * Gnration des Countrys (onglet)
     */
    init: function(){
        // initialisation du container DOM des onglets
        this.domTabs = $(structure.tabs);
        
        // initialisation du container DOM des panneaux
        this.domPanels = $(structure.body);
        
        var d = this.opt.data;
        // initialisation des onglets des pays
        for (var i = 0; i < d.length; ++i) {
            this.addItem(new Country(this, d[i].country));
        }
        this.hidePanels();
        var s = this;
		
        popularTab = {
            "tab": $("#" + structure.popular).parent(),
            "panel": $("#" + structure.popular + keywords.separator + keywords.content)
        };
        popularTab.tab.click(function(){
            s.selectItem(popularTab);
			return false;
        });
		
        $("a", popularTab.panel).click(function(){
            updateParent(this);
			return false;
        })
       
        this.items.push(popularTab);
		
    },
    hidePanels: function(){
        for (var i = 0; i < this.items.length; ++i) {
            this.items[i].tab.removeClass("current");
            this.items[i].panel.hide();
        }
    },
	plugBelgium:function()
	{var s=this;
		
		belgiumTab={
			"tab":$('<li id="belgium-tab"><a href="#">'+keywords.belgium+'</a></li>').appendTo(structure.tabs),
			"panel": $("#" + structure.belgium)
		}
	belgiumTab.panel.hide();
	belgiumTab.tab.click(function(){
		
            s.selectItem(belgiumTab);
			return false;
        });
	  $("a", belgiumTab.panel).click(function(){
            updateParent(this);
			return false;
        })
		this.items.push(belgiumTab);
	},
    /**
     * Ajoute un item au tabbox
     * @param {Country} country
     */
    addItem: function(/* Country */country){
		// Remove the line below to change Belgium tab management from include to default
		if (!defaultBelgiumTab)
		{
		
	   if(country.label==keywords.belgium )return this.plugBelgium();
	   } else {$("#" + structure.belgium).remove()}
        // cration de l'onglet
        var tab = $('<li><a href="#">' + country.label + '</a></li>');
        
        // Ajout de l'onglet au DOM
        this.domTabs.append(tab);
        
        // rcupration du contenu d'un panneau d'un pays
        var panel = country.domContainer;
        
        // Ajout du panel au DOM
        this.domPanels.append(panel);
        
        var s = this;
        
        var item = {
            "tab": tab,
            "panel": panel,
            "obj": country
        };
        
        // ajout de l'vnement d'affichage du panneau (prcd d'un appel  la mthode onshow de l'item)
        $('a', tab).click(function(){
            s.selectItem(item);
            return false;
        });
        
        // on garde la rfrence de l'item
        this.items.push(item);
    },
    selectItem: function(/* Object */item){
        this.hidePanels();
        if (item.obj && item.obj.onShow) {
            item.obj.onShow();
        }
        item.tab.addClass("current");
        item.panel.show();
    }
};

// ------------------------------------------------------------
/**
 * Les pays.
 *
 * composant IHM : Tabbox
 *
 * @param {PopupViewall} parent		PopupViewall parent.
 * @param {Object} data		Donnes JSON
 * 					Exemple de donnes :
 * 			{
 "label": "United Kingdom",
 "groups": [{
 "label": "A-G",
 "listLocalities": ["Aberdeen", "Ashford", "Aylesbury", "Banbury", "Bath Spa", "Beaconsfield", "Bedford", "Berwick Upon Tweed", "Bicester North", "Biggleswade", "Birmingham", "Birmingham International", "Bodmin Parkway", "Bridgend", "Brighton", "Bristol Parkway", "Bristol Temple Meads", "Cambridge", "Cardiff Central", "Carlisle", "Cheltenham Spa", "Chesterfield", "Chippenham", "Colchester", "Coventry", "Crewe", "Darlington", "Denham", "Derby", "Didcot Parkway", "Diss", "Doncaster", "Dunbar", "Durham", "Ebbsfleet", "Edinburgh", "Ely", "Exeter St Davids", "Flitwick", "Gatwick Airport", "Gerrards Cross", "Glasgow", "Gloucester", "Grantham", "Great Missenden"]
 }, {
 "label": "H-M",
 "listLocalities": ["Haddenham", "Harlington Beds", "Harpenden", "Hatfield (Herts)", "Hertford", "High Wycombe", "Hitchin", "Hull", "Huntingdon", "Ipswich", "Kemble", "Kettering", "Kings Lynn", "Kings Sutton", "Lancaster", "Leagrave", "Leamington Spa", "Leeds", "Leicester", "Letchworth", "Liskeard", "Liverpool", "London", "Loughborough", "Luton", "Luton Airport Parkway", "Macclesfield", "Manchester", "Manningtree", "Market Harborough", "Milton Keynes Central"]
 },
 "groupIntro": "UK stations"
 }
 */
function Country(/* PopupViewall */parent, /* Object */ data){
    var s = this;
    this.popupViewall = parent;
    this.data = data;
    this.label = data.label;
    this.prefix = data.groupIntro;
    
    // Container DOM principal de cet lment
    // /* JQuery */ this.domContainer;
    
    // Container DOM pour les onglets
    // /* JQuery */ this.domTabs;
    
    // Container DOM pour les panneaux
    // /* JQuery */ this.domPanels;
    
    // Liste des plages alphanumriques
    /* Array<Group> */
    this.items = [];
    this.domContainer = $('<div></div>');
}

Country.prototype = {
    /**
     * Initialisation de l'objet
     */
    init: function(){
        if (this.initialized) {
            return;
        }
        var s = this;
        
        var d = this.data.groups;
        this.intro = this.data.groupIntro;
        
        this.domTabs = $('<div class="group-control">' + this.intro + ' </div>').appendTo(this.domContainer);
        this.domPanels = $('<div></div>').appendTo(this.domContainer);
        for (var i = 0; i < d.length; ++i) {
            this.addItem(new Group(this, d[i]));
        };
        // init first item
        this.selectItem(this.items[0]);
        
        str = $.trim((this.domTabs.text()));
        
        if (str == "") {
            this.domTabs.hide()
        }
        this.initialized = true;
    },
    /**
     * Add an item to the Tabbox.
     *
     * @param {Group} group
     */
    addItem: function(/* Group */group){
        /* tab creation */
        tab = $('<a href="#">' + group.label + '</a>');
        this.domTabs.append(tab);
        
        // Fetch country panel
        var panel = group.domContainer;
        
        // add panel to DOM
        this.domPanels.append(panel);
        
        var s = this;
        
        var item = {
            "tab": tab,
            "panel": panel,
            "obj": group
        };
        
        // click event on the tab item
        item.tab.click(function(){
            s.selectItem(item)
            return false;
        });
        this.items.push(item);
    },
    onShow: function(){
        this.init();
    },
    hidePanels: function(){
        for (var i = 0; i < this.items.length; ++i) {
            this.items[i].tab.removeClass("current");
            this.items[i].panel.hide();
        }
    },
    selectItem: function(/* Object */item){
        this.hidePanels();
        if (item.obj && item.obj.onShow) {
            item.obj.onShow();
        }
        item.tab.addClass("current");
        item.panel.show();
    }
};



// ------------------------------------------------------------
/**
 * Les groupes de villes.
 *
 * composant IHM : PagedNav
 *
 */
function Group(/* Country */country,/* Object */ data){
    this.country = country;
    this.label = data.label;
    this.data = data;
    this.localities = []
    this.items = [];
    this.domContainer = $('<div></div>');
    
}

Group.prototype = {
    /**
     * Construction du code HTML et initialisation de comportement sur le click du libell.
     */
    init: function(){
        if (this.initialized) {
            return;
        }
        var s = this;
        
        var d = this.data.listLocalities;
        // Split the localities into Pages
        //Create as many pages as needed
        var pages = [];
        var i = 0;
        while (d.length > 0) {
            pages[i] = d.splice(0, layout.columns * layout.items);
            pages[i].label = i + 1;
            i++;
        }
        this.domPanels = $('<div></div>').appendTo(this.domContainer);
        this.domTabs = $('<div class="page-control"></div>').appendTo(this.domContainer);
		first = $('<a href="#">'+layout.first+'</a>').appendTo(this.domTabs);
	    previous = $('<a href="#">'+layout.previous+'</a>').appendTo(this.domTabs);
	
        for (var i = 0; i < pages.length; ++i) {
            this.addItem(new Localities(this, pages[i]));
        };
		next = $('<a href="#">'+layout.next+'</a>').appendTo(this.domTabs);
		last = $('<a href="#">'+layout.last+'</a>').appendTo(this.domTabs);
        this.selectItem(this.items[0]);
        if (pages.length == 1) {
            this.domTabs.hide()
        }
		var s=this;
		first.click(function(){
			s.selectFirst()
			return false;
		});
		previous.click(function(){
			s.selectPrevious()
			return false;
		})
		
		next.click(function(){
			s.selectNext()
			return false;
		})
		last.click(function(){
			s.selectLast()
			return false;
		})
        
        this.initialized = true;
    },
    addItem: function(/* Localities */localities){
        tab = $('<a href="#">' + localities.pageNumber + '</a>');
        
        this.domTabs.append(tab);
        
        // rcupration du contenu d'un panneau d'un liste
        var panel = localities.domContainer;
        
        // Ajout du panel au DOM
        this.domPanels.append(panel);
        
        var item = {
            "tab": tab,
            "panel": panel,
            "obj": localities
        };
        var s = this;
        // ajout de l'vnement d'affichage du panneau
        item.tab.click(function(){
            s.selectItem(item);
            return false;
        });
        this.items.push(item);
    },
    show: function(){
        this.hidePanels()
        
    },
    hide: function(){
    
    },
    hidePanels: function(){
        for (var i = 0; i < this.items.length; ++i) {
            this.items[i].tab.removeClass("current");
            this.items[i].panel.hide();
        }
    },
    onShow: function(){
        this.init();
    },
    selectItem: function(/* Object */item){
        this.hidePanels();
        if (item.obj && item.obj.onShow) {
            item.obj.onShow();
        }
        item.tab.addClass("current");
        item.panel.show();
    },
	selectFirst:function(){
		this.selectItem(this.items[0]);
	},
	selectLast:function(){
		
		this.selectItem(this.items[(this.items.length-1)]);
	},
	selectPrevious:function(){
		prevLink = $(".current", this.domTabs).prev("a");
		if (prevLink.html()==layout.previous) return;
		
			prevLink.trigger("click")
		
	},
	selectNext:function(){
		nextLink = $(".current", this.domTabs).next("a");
		if (nextLink.html()==layout.next) return;
		
			nextLink.trigger("click")
	}
};

/**
 * Les groupes de villes.
 *
 * composant IHM : 3colonnes
 *
 */
function Localities(/*Group*/group, /*data*/ data){
    this.group = group;
    this.data = data;
    this.pageNumber = data.label;
    this.items = [];
    this.domContainer = $('<div class="cancel-float"></div>');
}

Localities.prototype = {
    init: function(){
        var s = this;
        // slice in columns
        var cols = [];
        var i = 0;
        var d = this.data;
        while (d.length > 0) {
            cols[i] = d.splice(0, layout.items);
            i++;
        }
        for (var i = 0; i < cols.length; ++i) {
            this.addItem(new Col(this, cols[i]));
        };
        
            },
    
    
    onShow: function(){
        this.init();
    },
    addItem: function(/* Col */col){
        this.domContainer.append(col.domContainer);
        var item = {
            "obj": col
        };
        this.items.push(item);
    }
}
function Col(/*Localities*/localities, /*data*/ data){
    this.localities = localities;
    this.data = data;
    this.domContainer = $('<ul class="col"></ul>');
    this.init();
}

Col.prototype = {
    init: function(){
        var d = this.data
        for (var i = 0; i < d.length; i++) {
            this.addItem(new City(this, d[i]));
        };
            },
    addItem: function(/*City*/city){
        this.domContainer.append(city.domContainer);
    }
}
function City(/*Col*/col, /*data*/ data){
    this.domContainer = $("<li></li>");
    this.data = data;
    this.init();
}

City.prototype = {
    init: function(){
        link = $('<a href="#">' + this.data + '</a>').appendTo(this.domContainer);
        link.click(function(){
            updateParent(this);
			return false;
        })
    }
}



function updateParent(/* HTML A Element */o){
    thisTrigger = getTrigger();
    thisTrigger.value = $(o).text();
    reset();
    window.parent.fadeFrame();
    return false;
}

function getTrigger(){
    return window.parent.getTrigger()
}

function reset(){
	 popularTab.tab.trigger("click");
}

// ------------------------------------------------------------
$(function(){

    var p = new PopupViewall(this, {
        data: localities.listCountries
    });
    
    
})
