
// Survey actions when document is ready
$(document).ready(function() {

  // If cookie try to show the survey
  if (!$.cookie('survey')) {
    /**
     * Use probability to select a survey or not
     */
    var surveys = Drupal.settings.surveys,
        tir = Math.floor(Math.random()*101),
        sum_proba = 0,
        survey = false;

    for (var idx in surveys) {
      sum_proba += parseInt(surveys[idx].probability);
      if (sum_proba >= tir) {
        survey = surveys[idx];
        break ;
      }
    }
    if (survey == false) {
      return ;
    }
    
    /**
     * Fancybox doesn't support the manual autoload, so we add a hidden link after the body
     * and trigger the "click" event to show the popin
     */
    var link_id = 'survey_box';

    $("body").after('<a id="' + link_id + '" href="' + survey.alias + '" class="iframe hidden" style="display: none;">Open survey</a>');
    
    var $link_id = $('#' + link_id);
    
    $link_id.fancybox({
      "padding"               : 0,
      "overlayShow"           : true,
      "overlayOpacity"        : 0.4,
      "hideOnContentClick"    : false,
      "frameWidth"            : 415,  // If you change frameWidth, change width hack in callbackOnShow
      "frameHeight"           : 335,
      "centerOnScroll"        : false,
      "showCloseButton"       : true,
      "callbackOnClose": function() {
        // If fancybox has been closed without clicking 'yes' or 'no' button
        if ($.cookie('survey') === null) {
          $.cookie('survey', 1, {expires: survey.expires*30, path: '/', domain: survey.cookie_domain });
        }
      },
      "callbackOnShow": function() {
        var $fancy_close = $('#fancy_close');
        // Hack default css which set width to 690px
        $fancy_close.css('width', '415px');
    
        // Add closebutton to hack a bug
        $fancy_close.append('<a id="TB_closeWindowButton" class="closed">' + survey.close_text + '</a>');
      }
    });

    $link_id.click();
    
    $link_id.remove();
  }
});
